/* Program  extract.cc      */
/* By Harald Stauss         */
/* Last change 28 Feb. 1999 */

#include "tsa.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

main(int argc, char *argv[])
{
  int      i,chn1,chn2;
  unsigned long     n, lin1, lin2;
  float    sr=1.0;
  char     *fin, *fout, *ftin, *ftout;
  char     *fpin, *fpout, *fptin, *fptout;
  REGIST   r,o;
  
  printf("EXTRACT Ver.1.1 by H. Stauss, 1999 \n");

  /* A r r a y s   a l l o c i e r e n */
  fin=(char *)malloc(255); fpin=fin;
  fout=(char *)malloc(255); fpout=fout;
  ftin=(char *)malloc(255); fptin=ftin;
  ftout=(char *)malloc(255); fptout=ftout;
  
  if (argc!=7 && argc!=8)
    {
      printf("Number of parameters wrong! \n");
      printf("Extract channels number chn1 to chn2 and lines line1 to line2 \n");
      printf("0 for chn1, chn2, lin1, and lin2 takes max. values \n");
      printf("extract fin fout chn1 chn2 line1 line2 [sr]\n");
      printf("fin    : name of input file. \n");
      printf("fout   : name of output file. \n");
      printf("chn1   : first column to be writen to output \n");
      printf("chn2   : last  column to be writen to output \n");
      printf("line1  : first line to be writen to output \n");
      printf("line2  : last  line to be writen to output \n");
      printf("[sr]   : sampling rate if ASCII file \n");
      goto ende;
    }

  // Parameter einlesen;
  strcpy(fin ,argv[1]);
  strcpy(ftin,fin);
  fptin=strrchr(ftin,'.');
  for (i=0; fptin[i]; i++) fptin[i]=toupper(fptin[i]);
  strcpy(fout ,argv[2]);
  strcpy(ftout,fout);
  fptout=strrchr(ftout,'.');
  for (i=0; fptout[i]; i++) fptout[i]=toupper(fptout[i]);
  sscanf(argv[3],"%d",&chn1);
  sscanf(argv[4],"%d",&chn2);
  sscanf(argv[5],"%u",&lin1);
  sscanf(argv[6],"%u",&lin2);
  if (argc==8) sscanf(argv[7],"%f",&sr);

  // E i n g a b e d a t e i e n   o e f f n e n ;
  if (strcmp(fptin,".TSA")==0) r.ReadTSA(fin);
  if (strcmp(fptin,".ASC")==0) r.ReadASCII(fin,sr);
  if ((strcmp(fptin,".TSA")!=0) && (strcmp(fptin,".ASC")!=0)) {
    cout << "File type for input file not recognized! \n";
    goto ende;
  }

  if (chn1<=0) chn1=1;
  if (chn2<=0) chn2=r.n;
  if (chn2>r.n) chn2=r.n;
  if (lin1<=0) lin1=1;
  if (lin2<=0) lin2=r.ch[0].n;
  if (lin2>r.ch[0].n) lin2=r.ch[0].n;
     
  printf("In-File   : %s \n",fin);
  printf("Out-File  : %s \n",fout);
  printf("chn1      : %d \n",chn1);
  printf("chn2      : %d \n",chn2);
  printf("line1     : %u \n",lin1);
  printf("line2     : %u \n",lin2);
     
     
  printf("Number of channels: %d  \n",r.n);
  for (i=0; i < r.n; i++)
    printf("Number of lines in channel %d: %u \n",i+1,r.ch[i].n);
   
     
  // Kanaele in Registrierung o umkopieren;
  for (i=chn1-1; i<chn2; i++)
    o.AddChannel(lin2-lin1+1, r.ch[i].sr,
		 r.ch[i].min, r.ch[i].max,
		 r.ch[i].height, r.ch[i].color,
		 r.ch[i].name, r.ch[i].unit);
     
  for(i=chn1; i<=chn2; i++) {
    for(n=lin1; n<=lin2; n++) {
      o.ch[i-chn1].data[n-lin1]=r.ch[i-1].data[n-1];
    }
  }
     
  // D a t e i   s c h r e i b e n ;
  if (strcmp(fptout,".TSA")==0) o.WriteTSA(fout);
  if (strcmp(fptout,".ASC")==0) o.WriteASCII(fout);
  if ((strcmp(fptout,".TSA")!=0) && (strcmp(fptout,".ASC")!=0)) {
    printf("File type for output not recognized! \n");
    goto ende;
  }     
     
     
 ende:
  free(ftin);free(fin);free(fout);free(ftout);   
  return(0);
} /* Ende von main */







